<?php

namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Request\Filter;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\FilterCriteria;

class RelatorioLeadOperadorController extends TeknisaCrud {
    protected $dataSourceName = 'relatorioLeadOperador';
    protected $parameterBagColumns;
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        try{
            $criteria = $request->getFilterCriteria();
            $filters = $criteria->getConditions();
            
            foreach($filters as $key => $filter) {
                
                if($filter['columnName'] == 'NRPARCNEGOCIO') {
                    $parc_str = implode("", $filter['value']);
                    $NRPARCPROP_STR = array(
                        "columnName"  =>  "NRPARCPROP_STR",
                        "operator"    =>  "=",
                        "value"       =>  $parc_str
                    );
                    
                    array_push($filters, $NRPARCPROP_STR);
                }
                
                if($filter['columnName'] == 'DATEINTERVAL') {
                    $inicio = $filter['value'][0];
                    $fim = $filter['value'][1];
                    
                    $iniArr = array(
                        "columnName"  =>  "DTINIPERIODO",
                        "operator"    =>  "=",
                        "value"       =>  $inicio
                    );
                    
                    $fimArr = array(
                        "columnName"  =>  "DTFIMPERIODO",
                        "operator"    =>  "=",
                        "value"       =>  $fim
                    );
                    
                    array_push($filters, $iniArr, $fimArr);
                    array_splice($filters, $key, 1);
                }
            }
            
            $newCriteria = new FilterCriteria($criteria->getDataSourceName(),
                $filters, $criteria->getPage(), $criteria->getPageSize());
            
            
            $newReq = new Filter($newCriteria, $request->getMethod(),
                $request->getRoutePath(), $request->getUserId());
            
            parent::find($newReq, $response);
            
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
}