<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Teknisa\Model\Util\NovoCodigo;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Util\Functions;

class crm00026000ClassificacaoCasoController extends TeknisaCrud {
    protected $dataSourceName = 'crm_classificacaocaso';
    protected $sistema_dataSourceName = 'sistema_classificacao';
    protected $primaryKey = 'NRCLASSIFICACAOCASO';
    //protected $CDCONTADOR = 'NRCLASSIFICACAOCASO';

    public function save(DTO\Request $request, DTO\Response $response) {
    	foreach($request->getDataSet()->getRows() as $row) {
            if(!\Zeedhi\Framework\Util\Functions::arrayKeyExists('NRALERTACRM', $row)) $row['NRALERTACRM'] = null;
            if(!\Zeedhi\Framework\Util\Functions::arrayKeyExists('NRCORDESTAQUECASO', $row)) $row['NRCORDESTAQUECASO'] = null;
            if($row["__is_new"])
            {
                $row['__new_code_pk'] = "NRCLASSIFICACAOCASO";
                $row['__table_pk'] = "NRCLASSIFICACAOCASO";
                $row['__cast_number'] = true;
                $row['__new_code_length'] = 20;
            }
        }

    	parent::save($request, $response);
    }
    
    public function findSistema (DTO\Request\Filter $request, DTO\Response $response) {
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->sistema_dataSourceName;
        parent::find($request, $response);
        $this->dataSourceName = $previous_dataSourceName;
    }
    
    public function setSistema(DTO\Request\DataSet $request, DTO\Response $response) {
        
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->sistema_dataSourceName;
        $rows = $request->getDataSet()->getRows();
        
        foreach($rows as $row) {
            $row['NRCLASSIFICASISTEMA'] = NovoCodigo::geraCodigo($row['NRORG'], "NRCLASSIFICASISTEMA", 1, 10, false, false);
        }
        
        parent::save($request, $response);
        $this->dataSourceName = $previous_dataSourceName;
    }
    
    public function deleteSistema(DTO\Request\Row $request, DTO\Response $response) {
        
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->sistema_dataSourceName;
        
        parent::delete($request, $response);
        $this->dataSourceName = $previous_dataSourceName;
    }
}