<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response;

class crm30000ParticipantesCompromissoController extends TeknisaCrud {

    protected $dataSourceName = 'partplanocupa_operador';
    protected $environment;
    protected $enviarMensagemController;

    public function __construct ($crudService, $parameterBag, $environment, $enviarMensagemController, $parametrizacaoService)
    {
        $this->environment                = $environment;
        $this->enviarMensagemController   = $enviarMensagemController;
        $this->parametrizacaoService      = $parametrizacaoService;

        parent::__construct($crudService, $parameterBag);
    }
    
    public function save(DTO\Request $request, DTO\Response $response) {
        try{
            parent::save($request, $response);
            $rows = $request->getDataSet()->getRows();
            
            foreach($rows as $key => $row){
                $params = $this->parametrizacaoService->callGetCrmParametrization(array('NRORG' => $row['NRORG']))[0];
                if(empty($params['DSEMAILSMTP']) || empty($params['DSHOSTSMTP']) || empty($params['DSSENHASMTP']) || empty($params['DSPORTASMTP'])) {
                    $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet("error", array("Preencha os dados de envio de e-mail na tela Parametrização CRM!")));
                    break;
                }
                $secundaryRow = $row;
                $secundaryRow['TIPO'] = $row['TIPO'][$key];
                if(strtoupper($secundaryRow['TIPO']) === "INTERLOCUTOR") {
                    $nrseqinterlocutor = $row['NRPARCNEGOCIO'];
                    $cdoperresponsavel = null;
                }else {
                    $cdoperresponsavel = $row['CDOPERADOR'];
                    $nrseqinterlocutor = null;
                }
                $secundaryRow['NMOPERADORPART'] = $row['NMOPERADORPART'][$key];
                $secundaryRow['CDOPERADORPART'] = $row['CDOPERADORPART'][$key];
                $secundaryRow['DSEMAILOPER'] = $row['DSEMAILOPER'][$key];
                $this->notificaNovoParticipante($secundaryRow, $cdoperresponsavel, $nrseqinterlocutor);
            }
        }catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
        
    }
    
    public function notificaNovoParticipante($row, $cdoperresponsavel, $nrseqinterlocutor = null){
        $params = $this->parametrizacaoService->callGetCrmParametrization(array('NRORG' => $row['NRORG']))[0];
        if(empty($params['DSEMAILSMTP']) || empty($params['DSHOSTSMTP']) || empty($params['DSSENHASMTP']) || empty($params['DSPORTASMTP'])) {
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet("error", array("Preencha os dados de envio de e-mail na tela Parametrização CRM!")));
        } else {
            $from = $this->environment->getCdOperador();
            
            $mensagem = array();
            $mensagem['DSMENSAGEM']       = '<table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee" style="background-color: #eeeeee;"> <tbody> <tr> <td> <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="0274BA" class="container590" style="background-color: #0274ba; text-align: center;"> <tbody> <tr> <td> <table border="0" align="center" width="540" cellpadding="0" cellspacing="0" class="container580"> <tbody> <tr> <td align="center" valign="middle"> <table border="0" align="middle" cellpadding="0" cellspacing="0" style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;" class=""> <tbody> <tr> <td align="center" valign="middle"> <p style="color: #ffffff; font-size: 25px; padding:20px; font-family: " Questrial ", Helvetica, sans-serif; line-height: 25px; padding-top:45px;">NOTIFICAÇÃO DE COMPROMISSO </p> <p style="color: #ffffff; font-size: 16px; font-family: "Questrial", Helvetica, sans-serif; line-height: 15px; padding-top:15px;"> [DATACOMPROMISSO] </p> <p style="color: #ffffff; font-size: 16px; font-family: "Questrial", Helvetica, sans-serif; line-height: 15px; padding-top:15px;">&nbsp;</p> <p style="color: #ffffff; font-size: 16px; font-family: " Questrial ", Helvetica, sans-serif; line-height: 15px; padding-top:15px;"> <br> </p> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> <table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee"> <tbody> <tr> <td align="center"> <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="ffffff" class="container590 bg_color"> <tbody> <tr> <td> <table border="0" align="center" width="540" cellpadding="0" cellspacing="0" class="container580"> <tbody> <tr> <td align="left" style="color: #39434b; font-size: 20px; font-family: " Montserrat ", Helvetica, sans-serif; font-weight: 400; padding-bottom:15px; padding-top:20px; line-height: 35px;" class="title_color"> <div style="padding:20px; line-height: 22px"> Prezado(a) [PARTICIPANTE]</div> </td> </tr> <tr> <td align="left" class="title_color" style="color: #848999; font-size: 14px; font-family: " Questrial ", sans-serif; mso-line-height-rule: exactly; line-height: 24px; padding-bottom:15px;"> <div style="line-height: 24px;"> <p>O Operador [OPERADOR] inseriu você como participante no compromisso referente a(ao) [TIPO] [REFERENCIA]. <br> Segue os dados do Compromisso: . <ul> <li> <p>Referente a (ao): [TIPO] [REFERENCIA]</p> </li> <li> <p>Parceiro: [PARCEIRO]</p> </li> <li> <p>Data de Início: [DATACOMPROMISSO] </p> </li> <li> <p>Data de Fim: [DATAFINAL] </p> </li> <li> <p>Motivo: [MOTIVO] </p> </li> </ul> </p> <br> </div> </td> </tr> <tr> <td height="10" style="font-size: 10px; line-height: 10px;">&nbsp;</td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table>';
            $mensagem['DSTITULOMENSAGEM'] = 'CRM - Notificação de Compromisso';
            $mensagem['PARTICIPANTE']     = ucwords(strtolower($row['PARTICIPANTE']));   
            $mensagem['OPERADOR']         = ucwords(strtolower($row['OPERADOR']));
            $mensagem['TIPO']             = ucwords(strtolower($row['TIPOCOMPROMISSO']));
            $mensagem['PARCEIRO']         = ucwords(strtolower($row['PARCEIRO']));
            $mensagem['REFERENCIA']       = $row['REFERENCIA'];
            $mensagem['DATACOMPROMISSO']  = $row['DATACOMPROMISSO'];
            $mensagem['DATAFINAL']        = $row['DATAFINAL'];
            $mensagem['MOTIVO']           = $row['MOTIVO'];
            
            $this->enviarMensagemController->enviarEmail($mensagem, $row['NRORG'], $cdoperresponsavel, $from, null, null, null, null, $nrseqinterlocutor);
        }
    }
}