<?php

namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class IntegracaoRDStationFactory {

    protected $connection;
    protected $environment;

    public function __construct(EntityManager $entityManager, $environment) {
        $this->connection  = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    public function getCdmododivulgRdstation($entityManager, $org){
        $select = "SELECT CDMODODIVULG FROM MODODIVULG WHERE IDRDSTATION = 'S' AND NRORG = $org";
        
        try{
            $std = $entityManager->getConnection();
            $std = $std->prepare($select);
            $std->execute();
            $mododivulg = $std->fetchAll();
            return $mododivulg[0]['CDMODODIVULG'];
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function getOperRdstation($entityManager, $org){
        $select = "SELECT OPER.CDOPERADOR, OPER.NRPARCNEGOCIO FROM OPERADOR OPER JOIN CRM_PARAMETRIZACAO PARAM 
                    ON PARAM.CDOPERRESPONSAVELRD = OPER.CDOPERADOR AND PARAM.NRORG = OPER.NRORG WHERE OPER.NRORG = $org";
        
        try{
            $std = $entityManager->getConnection();
            $std = $std->prepare($select);
            $std->execute();
            $oper = $std->fetchAll();
            return empty($oper) ? array() : $oper[0];
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function getCreateTaskParam($entityManager, $org){
        $select = "SELECT IDGERATAREFARD FROM CRM_PARAMETRIZACAO WHERE NRORG = $org";
        
        try{
            $std = $entityManager->getConnection();
            $std = $std->prepare($select);
            $std->execute();
            $param = $std->fetchAll();
            return $param[0];
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function searchLead($entityManager, $org, $email){
        $select = "SELECT LEAD.NRPARCNEGOCIO, LEAD.NRSEQCONTATO FROM CRM_CANDIDATO LEAD JOIN CRM_INTERLOCUTOR INTERLOC ON INTERLOC.EMAILINTERLOC = LEAD.DSEMAILCAN AND LEAD.NRORG = INTERLOC.NRORG WHERE LEAD.NRORG = $org AND DSEMAILCAN = '$email'";
        
        try{
            $std = $entityManager->getConnection();
            $std = $std->prepare($select);
            $std->execute();
            $lead = $std->fetchAll();
            return empty($lead) ? array() : $lead[0];
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function getEventsRDParam($entityManager, $org){
        $select = "SELECT UPPER(NMEVENTOSCONVERSAO) NMEVENTOSCONVERSAO FROM CRM_PARAMETRIZACAO WHERE NRORG = $org ";
        
        try{
            $std = $entityManager->getConnection();
            $std = $std->prepare($select);
            $std->execute();
            $events = $std->fetchAll();
            return empty($events) ? '' : $events[0]['NMEVENTOSCONVERSAO'];
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function getScoresRDParam($entityManager, $org){
        $select = "SELECT UPPER(DSSCORERD) DSSCORERD FROM CRM_PARAMETRIZACAO WHERE NRORG = $org ";
        
        try{
            $std = $entityManager->getConnection();
            $std = $std->prepare($select);
            $std->execute();
            $scores = $std->fetchAll();
            return empty($scores) ? '' : $scores[0]['DSSCORERD'];
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function getDomainsRDParam($entityManager, $org){
        $select = "SELECT UPPER(DSDOMINIOSRD) DSDOMINIOSRD FROM CRM_PARAMETRIZACAO WHERE NRORG = $org ";
        
        try{
            $std = $entityManager->getConnection();
            $std = $std->prepare($select);
            $std->execute();
            $domains = $std->fetchAll();
            return empty($domains) ? '' : $domains[0]['DSDOMINIOSRD'];
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function getJobTitleRDParam($entityManager, $org){
        $select = "SELECT UPPER(DSCARGOSRD) DSCARGOSRD FROM CRM_PARAMETRIZACAO WHERE NRORG = $org ";
        
        try{
            $std = $entityManager->getConnection();
            $std = $std->prepare($select);
            $std->execute();
            $jobs = $std->fetchAll();
            return empty($jobs) ? array() : $jobs[0]['DSCARGOSRD'];
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function getTasksOpen($entityManager, $org, $nrparcnegocio){
        $select = "SELECT 1 FROM FILACONTATO WHERE NRORG = $org AND NRPARCNEGOCIO = $nrparcnegocio AND DTREALFILACONTA IS NULL";
        
        try{
            $std = $entityManager->getConnection();
            $std = $std->prepare($select);
            $std->execute();
            $taksOpen = $std->fetchAll();
            return empty($taksOpen) ? array() : $taksOpen;
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function getRefreshToken(){
        $nrorg = $this->environment->getNrOrgTrab();
        $select = "SELECT DSREFRESHTOKENRD FROM CRM_PARAMETRIZACAO WHERE NRORG = $nrorg";
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            $token = $std->fetchAll();
            return empty($token) ? array() : $token[0]['DSREFRESHTOKENRD'];
        }
        catch(\Exception $e){
            throw $e;
        };    
    }
    
    public function saveRefreshToken($refreshToken){
        $nrorg = $this->environment->getNrOrgTrab();
        $update = "UPDATE CRM_PARAMETRIZACAO SET DSREFRESHTOKENRD = '$refreshToken' WHERE NRORG = $nrorg";
        try{
            $std = $this->connection->prepare($update);
            $std->execute();
        }
        catch(\Exception $e){
            throw $e;
        };    
    }
    
    public function getPublicTokenRD($entityManager = null){
        $nrorg = $this->environment->getNrOrgTrab();
        
        $select = "SELECT DSTOKENPUBLICORD FROM CRM_PARAMETRIZACAO WHERE NRORG = $nrorg";
        
        try{
            if($entityManager !== null){
                $std = $entityManager->getConnection();
                $std = $std->prepare($select);
            }else{
                $std = $this->connection->prepare($select);
            }
            $std->execute();
            $token = $std->fetchAll();
            return empty($token) ? array() : $token[0]['DSTOKENPUBLICORD'];
        }
        catch(\Exception $e){
            throw $e;
        };    
    }
    
    public function getPrivateTokenRD(){
        $nrorg = $this->environment->getNrOrgTrab();
        $select = "SELECT DSTOKENPRIVADORD FROM CRM_PARAMETRIZACAO WHERE NRORG = $nrorg";
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            $token = $std->fetchAll();
            return empty($token) ? array() : $token[0]['DSTOKENPRIVADORD'];
        }
        catch(\Exception $e){
            throw $e;
        };    
    }
    
    public function getCustomFields($filter = null, $entityManager = null){
        $nrorg = $this->environment->getNrOrgTrab();
        $select = "SELECT NMCAMPORDSTATION, NMCAMPO, NMTABELA, NMCAMPORELACIONADO, NMTABELARELACIONADA FROM CRM_CAMPOSRDSTATION WHERE NRORG = $nrorg";
        
        if($filter !== null)
            $select = "SELECT NMCAMPORDSTATION, NMCAMPO, NMTABELA, NMCAMPORELACIONADO, NMTABELARELACIONADA FROM CRM_CAMPOSRDSTATION WHERE NRORG = $nrorg $filter";
        
        try{
            if($entityManager !== null){
                $std = $entityManager->getConnection();
                $std = $std->prepare($select);
            }else{
                $std = $this->connection->prepare($select);
            }
            $std->execute();
            $fields = $std->fetchAll();
            return empty($fields) ? array() : $fields;
        }
        catch(\Exception $e){
            throw $e;
        };    
    }
    
    public function getValueOfCustomFields($select, $from, $where, $entityManager = null){
        $nrorg = $this->environment->getNrOrgTrab();
        $select = "SELECT $select FROM $from WHERE $where";
        
        try{
            if($entityManager !== null){
                $std = $entityManager->getConnection();
                $std = $std->prepare($select);
            }else{
                $std = $this->connection->prepare($select);
            }
            $std->execute();
            $fieldsValue = $std->fetchAll();
            return empty($fieldsValue) ? array() : $fieldsValue[0];
        }
        catch(\Exception $e){
            throw $e;
        };    
    }
    
    public function setCustomField($table, $field, $value, $nrparcnegocio, $entityManager){
        $nrorg = $this->environment->getNrOrgTrab();
        $update = "UPDATE $table SET $field = '$value' WHERE NRORG = $nrorg AND NRPARCNEGOCIO = $nrparcnegocio";
        
        try{
            $std = $entityManager->getConnection();
            $std = $std->prepare($update);
            $std->execute();
        }
        catch(\Exception $e){
            throw $e;
        };    
    }
    
    public function getOwnerOper($entityManager, $org, $ownerMail){
        $select = "SELECT OPER.CDOPERADOR, OPER.NRPARCNEGOCIO FROM OPERADOR OPER WHERE OPER.NRORG = $org AND OPER.DSEMAILOPER = '$ownerMail'";
        
        try{
            $std = $entityManager->getConnection();
            $std = $std->prepare($select);
            $std->execute();
            $oper = $std->fetchAll();
            return empty($oper) ? array() : $oper[0];
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function checkIfHasOpenOpport($email){
        $nrorg = $this->environment->getNrOrgTrab();
        $select = "SELECT NRSEQOPORT FROM CRM_OPORTUNI OPORT JOIN CRM_INTERLOCUTOR INTERLOC ON INTERLOC.NRPARCNEGOCIO = OPORT.NRPARCOPORT AND INTERLOC.NRORG = OPORT.NRORG WHERE DTREALFECHA IS NULL AND INTERLOC.EMAILINTERLOC = '$email' AND OPORT.NRORG = $nrorg";
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            $oport = $std->fetchAll();
            return empty($oport) ? false : true;
        }
        catch(\Exception $e){
            throw $e;
        };    
    }
    
}