/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CALEPRODUCAO                                             */
/* Tabela : CALEPRODUCAO                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 24/04/2007 - Ronald Reis                                                   */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CALEPRODUCAO
BEFORE INSERT OR UPDATE OR DELETE
ON CALEPRODUCAO FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCALP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFILIAL,'Z') <> NVL(:NEW.CDFILIAL,'Z'))       OR
         (NVL(:OLD.CDPERIPRODU,'Z') <> NVL(:NEW.CDPERIPRODU,'Z')) OR
         (NVL(:OLD.DTPRODUCAO,'Z') <> NVL(:NEW.DTPRODUCAO,'Z')     ) THEN
         :NEW.DTULTATUCALP := SYSDATE;
      END IF;
   END IF;   
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE,  DTULTATUCACH)
                       VALUES ('CALEPRODUCAO', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDPERIPRODU='||:OLD.CDPERIPRODU||
                               ';DTPRODUCAO='||:OLD.DTPRODUCAO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CALEPRODUCAO MODIFY DTULTATUCALP DEFAULT SYSDATE
/
-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_CALEPRODUCAO','4.11.134'); END;
/
