/* Tabela SEQNUMELOCA: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela SEQNUMELOCA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela SEQNUMELOCA utilizando a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_CTRLFORMNF
AFTER DELETE OR INSERT OR UPDATE
ON CTRLFORMNF FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN

      IF :OLD.CDCTRLNUMENF IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :OLD.CDCTRLNUMENF;
      END IF;

      IF :OLD.NRCTRLFORMNF IS NOT NULL THEN
         V_DESC := V_DESC || ' CtrlForm=' || :OLD.NRCTRLFORMNF;
      END IF;

      IF :OLD.CDLOCALEMIS IS NOT NULL THEN
         V_DESC := V_DESC || 'LocalEmis=' || :OLD.CDLOCALEMIS;
      END IF;

      IF :OLD.NRNUMEINIFRM IS NOT NULL THEN
         V_DESC := V_DESC || '  NrInicial=' || :OLD.NRNUMEINIFRM;
      END IF;

      IF :OLD.NRNUMEFINFRM IS NOT NULL THEN
         V_DESC := V_DESC || ' NrFinal=' || :OLD.NRNUMEFINFRM;
      END IF;

      IF :OLD.DTLIBESEQUNF IS NOT NULL THEN
         V_DESC := V_DESC || ' DataLibera=' || :OLD.DTLIBESEQUNF;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDCTRLNUMENF||:OLD.NRCTRLFORMNF;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDCTRLNUMENF <> :NEW.CDCTRLNUMENF)  OR
            (:OLD.NRCTRLFORMNF <> :NEW.NRCTRLFORMNF)  OR
            (:OLD.CDLOCALEMIS  <> :NEW.CDLOCALEMIS )  OR
            (:OLD.NRNUMEINIFRM <> :NEW.NRNUMEINIFRM)  OR
            (:OLD.NRNUMEFINFRM <> :NEW.NRNUMEFINFRM)  OR
            (:OLD.DTLIBESEQUNF <> :NEW.DTLIBESEQUNF)  THEN

            IF :NEW.CDCTRLNUMENF <> :OLD.CDCTRLNUMENF THEN
               V_DESC := V_DESC || 'Cod=' || :NEW.CDCTRLNUMENF;
            END IF;

            IF :NEW.NRCTRLFORMNF <> :OLD.NRCTRLFORMNF THEN
               V_DESC := V_DESC || ' CtrlForm=' || :NEW.NRCTRLFORMNF;
            END IF;

            IF :NEW.CDLOCALEMIS <> :OLD.CDLOCALEMIS THEN
               V_DESC := V_DESC || 'LocalEmis=' || :NEW.CDLOCALEMIS;
            END IF;

            IF :NEW.NRNUMEINIFRM <> :OLD.NRNUMEINIFRM THEN
               V_DESC := V_DESC || '  NrInicial=' || :NEW.NRNUMEINIFRM;
            END IF;

            IF :NEW.NRNUMEFINFRM <> :OLD.NRNUMEFINFRM THEN
               V_DESC := V_DESC || ' NrFinal=' || :NEW.NRNUMEFINFRM;
            END IF;

            IF :NEW.DTLIBESEQUNF <> :OLD.DTLIBESEQUNF THEN
               V_DESC := V_DESC || ' DataLibera=' || :NEW.DTLIBESEQUNF;
            END IF;         V_TIPO         := '1';

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDCTRLNUMENF||:OLD.NRCTRLFORMNF;
         END IF;
      ELSE
         IF :NEW.CDCTRLNUMENF IS NOT NULL THEN
            V_DESC := V_DESC || 'Cod=' || :NEW.CDCTRLNUMENF;
         END IF;

         IF :NEW.NRCTRLFORMNF IS NOT NULL THEN
            V_DESC := V_DESC || ' CtrlForm=' || :NEW.NRCTRLFORMNF;
         END IF;

         IF :NEW.CDLOCALEMIS IS NOT NULL THEN
            V_DESC := V_DESC || 'LocalEmis=' || :NEW.CDLOCALEMIS;
         END IF;

         IF :NEW.NRNUMEINIFRM IS NOT NULL THEN
            V_DESC := V_DESC || '  NrInicial=' || :NEW.NRNUMEINIFRM;
         END IF;

         IF :NEW.NRNUMEFINFRM IS NOT NULL THEN
            V_DESC := V_DESC || ' NrFinal=' || :NEW.NRNUMEFINFRM;
         END IF;

         IF :NEW.DTLIBESEQUNF IS NOT NULL THEN
            V_DESC := V_DESC || ' DataLibera=' || :NEW.DTLIBESEQUNF;
         END IF;
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDCTRLNUMENF||:NEW.NRCTRLFORMNF;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('CTRLFORMNF',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_CTRLFORMNF','4.09.063'); END;
/

